/*
	bsd.h

	Copyright (c) 1996, 1997 by Global Constructs.  All Rights Reserved.

	last modified 10/17/97
*/

/* C problems */

#define EMPTY_ARRAY	0

/* Set up variable headers */

#define STAT_H		<sys/stat.h>
#define STD_H		<unistd.h>
#define IO_H		<stdio.h>
#define FCNTL_H		<fcntl.h>
#define TYPES_H		<sys/types.h>
#define DIRECT_H	<direct.h>
#define LIMITS_H	<limits.h>
#define STRINGS_H	<string.h>
#define MALLOC_H	<stdlib.h>

#define NETDB_H		<netdb.h>
#define INET_H		<arpa/inet.h>
#define TIME_H		<sys/time.h>
#define SOCKET_H	<sys/socket.h>
#define IN_H		<netinet/in.h>

/* Make sure integers are the right size */
typedef signed long			int32;
typedef unsigned long		int32u;
typedef signed short		int16;
typedef unsigned short		int16u;
typedef unsigned char		int8u;
typedef signed char			int8;

typedef float				float32;
typedef double				float64;
typedef long double			float128;

/* Make sure maximum and minimum macros agree */
#include LIMITS_H

#define INT32_MAX	LONG_MAX
#define INT32_MIN	LONG_MIN
#define INT32U_MAX	ULONG_MAX
#define INT16_MAX	SHRT_MAX
#define INT16_MIN	SHRT_MIN
#define INT16U_MAX	USHRT_MAX
#define BYTE_MAX	SCHAR_MAX
#define BYTE_MIN	SCHAR_MIN
#define INT8U_MAX	UCHAR_MAX

/* File path variations */

#define DIR_SEPARATER		"/"
#define DIR_SEPARATER_CHAR	'/'

/* localy emulated routines */

#define min(a,b)	(((a) < (b)) ? (a) : (b))
#define max(a,b)	(((a) > (b)) ? (a) : (b))

/* Only special stuff below this line */

/* unix open() does not use O_BINARY */
#define O_BINARY	0x00

