/*
	ftrunc.c
	Copyright (c) 1996, 1997, by Global Constructs.  All Rights Reserved.

	last modified 1/18/97
*/
#include "common.h"
#include STAT_H
#include IO_H

/*
	int ftruncate(int fd, off_t size)

	Emulation of ftruncate for non-compliant systems

	Parameters
	fh		File handle number
	size	New size of file

	Returns zero if successful, otherwise -1 and errno is set

	KBLs	File is only truncated if smaller.  A size parameter larger than
			the current file size will not extend the file.	
*/
int ftruncate(int fh, off_t size)
{
	struct stat	 fbuf;

	fstat(fh, &fbuf);
	if(fbuf.st_size < size)
		size = fbuf.st_size;

	return (chsize(fh, size));
}

