/*
    mclose.c

    Copyright (c) 1996, 1997, by Global Constructs.  All Rights Reserved.

	last modified 10/17/97
*/
#include <stdlib.h>

#include "common.h"
#include STD_H
#include <stdio.h>
#include "memlib.h"
#include "memfile.h"

fileHandle *gc1sthandle = NULL;	/* pointer to file handle list */

int16 mclose(int16 handle)
{
    fileList *fptr;
    fileHandle *hptr, *tmp_hptr, *oth_hptr;
    memList *mptr, *tmp_mptr;

    /* get file list pointer */
    hptr = getfilehandle(handle);
    if (hptr == NULL) {
        errmem = badFileHandle;
        return (-1);
    }
    /*
        Removal of the file includes the following steps.
        1.  Remove the fileHandle pointer from the handle list.
        2.  Check for other files handle for file.
        3.  Remove the fileList pointer from the file list.
        4.  Free the memory for the filename.
        5.  Free the memory for the memory blocks.
        6.  Free the memory for the memory list structures.
        7.  Free the memory for the file list structure.
    */
    if (firsthandle == hptr)
        firsthandle = firsthandle->h_next;
    else
        for (oth_hptr=firsthandle;oth_hptr;oth_hptr=oth_hptr->h_next)
            if (oth_hptr->h_next == hptr) {
                /* set home pointer to pointer of next block after ours */
                oth_hptr->h_next = hptr->h_next;
                break;
            }
    for (tmp_hptr=firsthandle;tmp_hptr;tmp_hptr=tmp_hptr->h_next)
        if (tmp_hptr->file == hptr->file && tmp_hptr != hptr) {
            free (hptr);
            return 0;
        }
    if (firstlist == hptr->file)
        firstlist = firstlist->f_next;
    else
        for (fptr=firstlist;fptr;fptr=fptr->f_next)
            if (fptr->f_next == hptr->file) {
                /* set home pointer to pointer of next block after ours */
                fptr->f_next = hptr->file->f_next;
                break;
            }
    /* free filename memory */
	/* PTW: only if there is a filename 1-14-1997 */
    if(hptr->file->filename) free(hptr->file->filename);
    /* close sync handle */
    if (hptr->file->filemode & M_ISYNC) {
        /* dump changes to disk based file */
        hptr->file->synczero = 1;
        syncfile(hptr->file);
		close((int)hptr->file->synchandle);
    }
    for (mptr=hptr->file->memsegments;mptr;) {
        tmp_mptr = mptr->m_next;    /* get next memory ptr before we free it */
        free(mptr);                 /* free memory list */
        mptr = tmp_mptr;
    }
    free(hptr->file);
    free(hptr);
    return 0;
}


