/*
    mdup.c

    Copyright (c) 1996, 1997, by Global Constructs.  All Rights Reserved.

	 last modified 1/6/97
*/
#include "memlib.h"
#include "memfile.h"

int16 mdup(int16 handle)
{
	fileHandle *hptr, *tptr;
	int16 fh;

	hptr = getfilehandle(handle);
	if (hptr == NULL) {
		errmem = badFileHandle;
		return (-1);
	}
	/* Only one handle is permitted for stack file operations */
	if (hptr->file->filemode & (M_IFIFO | M_IFILO)) {
		errmem = stackFileDup;
		return (-1);
	}
	/* Only one handle is permitted for exclusive access memory files */
	if (hptr->fileaccess & I_EXCL) {
		errmem = exclAccessDenied;
		return (-1);
	}
	if ((fh = addfilehandle(hptr->file, 0)) < 0)
		return (-1);
	tptr = getfilehandle(fh);
	if (tptr == NULL) {
		errmem = badFileHandle;
		return (-1);
	}
	tptr->filepos = hptr->filepos;
	tptr->fileaccess = hptr->fileaccess;
	tptr->eof = hptr->eof;
	tptr->last = hptr->last;
	return fh;
}


