/*
    mseek.c

    Copyright (c) 1996, by Global Constructs.  All Rights Reserved.

    last modified 12/24/96
*/
#include <stdio.h>
#include "memlib.h"

int32 mseek( int16 handle, int32 offset, int16 whence )
{
	fileHandle *hptr;

	/* get file list pointer */
	hptr = getfilehandle(handle);
	if (hptr == NULL) {
		errmem = badFileHandle;
		return (-1);
	}
	switch(whence) {
		case SEEK_SET:	/* seek from beginning of file */
			if (hptr->file->filemode & (M_IFIFO | M_IFILO)) {
				errmem = stackFileSeek;
				return (-1);
			}
			if (offset < 0) {
				errmem = seekPastBeginning;
				return (-1);
			}
			hptr->filepos = offset;
			if (hptr->filepos < hptr->file->filesize)
				hptr->eof = FALSE;
			else
				hptr->eof = TRUE;
			return hptr->filepos;
		case SEEK_CUR:	/* seek from current position */
			if (hptr->file->filemode & (M_IFIFO | M_IFILO) && offset != 0) {
				errmem = stackFileSeek;
				return (-1);
			}
			if ((offset < 0) && (offset + hptr->filepos < 0)) {
				errmem = seekPastBeginning;
				return (-1);
			}
			hptr->filepos += offset;
			if (hptr->filepos < hptr->file->filesize)
				hptr->eof = FALSE;
			else
				hptr->eof = TRUE;
			return hptr->filepos;
		case SEEK_END:	/* seek from end of file */
			if (hptr->file->filemode & (M_IFIFO | M_IFILO)) {
				errmem = stackFileSeek;
				return (-1);
			}
			if (offset < 0 && offset + hptr->file->filesize < 0) {
				errmem = seekPastBeginning;
				return (-1);
			}
			hptr->filepos = hptr->file->filesize + offset;
			if (hptr->filepos < hptr->file->filesize)
				hptr->eof = FALSE;
			else
				hptr->eof = TRUE;
			return hptr->filepos;
		default:
			errmem = invalidParameter;
			return (-1);
	}
}


