/*
    mstrerr.c

    Copyright (c) 1996, by Global Constructs.  All Rights Reserved.

    last modified 12/24/96
*/
#include "memlib.h"

const char *mstrerror( int16 errnum )
{
    switch(errnum) {
        case 0:
            return ("No error encountered.");
        case badFileHandle:
            return ("Bad file handle.");
        case fileModeConflict:
            return ("More than one file type is specified.");
        case accessModeConflict:
            return ("More than one of I_RDONLY, I_WRONLY, and I_RDWR is specified.");
        case loadFailFileExists:
            return ("Load from disk failed due to pre-existing memory file.");
        case exclCreateFailed:
            return ("Exclusive create failed due to pre-existing memory file.");
        case exclAccessDenied:
            return ("Exclusive access denied on pre-existing memory file.");
        case fileNotReadable:
            return ("File mode or access does not permit reading.");
        case fileNotWritable:
            return ("File mode or access does not permit writing.");
        case stackFileDup:
            return ("Duplicate file handles for stacked memory files are not permitted.");
        case stackFileSeek:
            return ("Change of file position for stacked memory files is restricted.");
        case stackFileRead:
            return ("Routine mread() not permitted on stacked memory files.");
        case pullNotAllowed:
            return ("Routine mpull() not permitted on normal memory files.");
        case noTruncOnRead:
            return ("File truncation not allowed on read only memory files.");
        case fileDoesNotExist:
            return ("File does not exist.");
        case syncDiskFileOnly:
            return ("Sync permitted with disk based files only.");
        case syncSeekFailure:
            return ("Error seeking to disk based file during synchronization.");
        case syncWriteFailure:
            return ("Error writing to disk based file during synchronization.");
        case outOfMemory:
            return ("Out of or too low on memory.");
        case diskReadError:
            return ("Error loading disk based file.");
        case invalidBufferPtr:
            return ("NULL pointer reference to buffer parameter.");
        case maxFileSizeExceeded:
            return ("Write operation exceeded maximum file size limit.");
        case seekPastBeginning:
            return ("Seek attempted before beginning of memory file.");
        case invalidParameter:
            return ("Invalid parameter value attempted.");
        case tooManyOpenHandles:
            return ("Too many open file handles to memory files.");
        default:
            return ("Unknown error occurred.");
    }
}



