/*
	mtrunc.c

	Copyright (c) 1996, 1997, by Global Constructs.  All Rights Reserved.

	last modified 1/6/97
*/
#include <stdlib.h>
#include "memlib.h"

static void zerofilepositionpointer( fileList * );

int16 mtruncate(int16 handle, int32 newsize)
{
	memList *mptr, *tmptr;
	fileHandle *hptr;

	/* get file list pointer */
	hptr = getfilehandle(handle);
	if (hptr == NULL) {
		errmem = badFileHandle;
		return (-1);
	}
	if (newsize < 0) {
		errmem = invalidParameter;
		return (-1);
	}
	if (newsize >= hptr->file->filesize)
		return 0;
	if (hptr->fileaccess & (I_WRONLY | I_RDWR)) {
		hptr->file->filesize = newsize;
		for (mptr=hptr->file->memsegments;mptr;mptr=mptr->m_next) {
			if (newsize > mptr->fblock_size) {
				newsize -= mptr->fblock_size;
			} else {
				mptr->fblock_size = newsize;
				mptr->free_size = mptr->m_size - mptr->fblock_size;
				/* free rest of memory */
				tmptr = mptr->m_next;
				mptr->m_next = NULL;
				hptr->file->memsegments->m_prev = mptr;
				for(;tmptr;tmptr=mptr) {
					mptr = tmptr->m_next;
					hptr->file->clustersize -= tmptr->m_size;
					hptr->file->numsegments--;
					/* removed line to free m_ptr, 10297, CAS */
					free(tmptr);
				}
				break;
			}
		}
	} else {
		errmem = fileNotWritable;
		return (-1);
	}
	zerofilepositionpointer(hptr->file);
	syncfile(hptr->file);
	return 0;
}

/*
	void zerofilepositionpointer(fileList *fptr)

	Searches file handle list and clears all memory list pointers in the file
	handles related to that file.  Used when memory block is removed from file
	list for normal file.

	Parameters
	fptr	Pointer to file list

	Returns void.

	KBLs	None.
*/
static void zerofilepositionpointer(fileList *fptr)
{
	fileHandle *ptr;

	for(ptr=firsthandle;ptr;ptr=ptr->h_next)
		if (ptr->file == fptr)
			ptr->last.fpptr = NULL;
}

