/*
    OS2.h
    Copyright (c) 1996, 1997, by Global Constructs.  All Rights Reserved.

    last modified 1/18/97
*/

/* C problems */

#define EMPTY_ARRAY

/* Set up variable headers */

#define STAT_H		<sys/stat.h>
#define STD_H		<unistd.h>
#define IO_H		<io.h>
#define FCNTL_H		<fcntl.h>
#define MIN_H		<stdlib.h>
#define TYPES_H		<sys/types.h>

#if defined( __TURBOC__ )
#define DIRECT_H	<dir.h>
#elif defined( __WATCOMC__ )
#define DIRECT_H	<direct.h>
#endif

#define LIMITS_H	<limits.h>
#define STRINGS_H	<string.h>
#define MALLOC_H	<stdlib.h>

#define NETDB_H
#define INET_H
#define TIME_H
#define SOCKET_H
#define IN_H

#include TYPES_H

/* Make sure integers are the right size */

typedef struct{
	signed long			low;
	signed long			high;
}	int64;
typedef struct{
	unsigned long		low;
	unsigned long		high;
}	int64u;
typedef signed long			int32;
typedef unsigned long		int32u;
typedef signed short		int16;
typedef unsigned short		int16u;
typedef unsigned char		int8u;
typedef signed char			int8;

typedef float				float32;
typedef double				float64;
typedef long double			float128;

/* Make sure maximum and minimum macros agree */
#include LIMITS_H

#define INT32_MAX	LONG_MAX
#define INT32_MIN	LONG_MIN
#define INT32U_MAX	ULONG_MAX
#define INT16_MAX	SHRT_MAX
#define INT16_MIN	SHRT_MIN
#define INT16U_MAX	USHRT_MAX
#define BYTE_MAX	SCHAR_MAX
#define BYTE_MIN	SCHAR_MIN
#define INT8U_MAX	UCHAR_MAX

/* File path variations */

#define DIR_SEPARATER		"\\"
#define DIR_SEPARATER_CHAR	'\\'

#ifdef __TURBOC__
#define filenamesplit(a,b,c,d,e)	fnsplit(a, b, c, d, e)
#else
#define filenamesplit(a,b,c,d,e)	_splitpath(a, b, c, d, e)
#endif

/* 64 Bit Replacement Routines */

/* assign64 assigns a 64 Bit integer (y) to a 64 Bit integer (x) */
#define assign64(x,y) (((x).low = (y).low),((x).high = (y).high))

/* assign64zero sets a 64 Bit integer to zero */
#define assign64zero(x) (((x).low = (int32u)0),((x).high = (int32u)0))

/* assign64str assigns an 8 byte array (y) to a 64 Bit integer (x) */
#define assign64str(x,y) (((x).low = *(int32u *)(y)),((x).high = *(int32u *)((y)+sizeof(int32u))))

/* test64 returns true if a 64 Bit integer is not zero */
#define test64(x) ((x).low || (x).high)

/* compare64 tests for 64 Bit equivelance */
#define compare64(x,y) (((x).low == (y).low) && ((x).high == (y).high))

/* locally emulated routines */

#define bcopy(a,b,c)	memcpy(b,a,c)

int ftruncate(int, off_t);

#define LOCK_SH 1
#define LOCK_EX	2
#define LOCK_NB	4
#define LOCK_UN	8

int16 flock(int16, int16);

int setcwd(char *);

/* Only special stuff below this line */


